/**
 * @function _scaledSize
 */

"use strict";

import numcal from 'numcal'

function _scaledSize (contentSize, frameSize, policy) {
  let cw = contentSize.width
  let ch = contentSize.height
  let fw = frameSize.width
  let fh = frameSize.height

  let wRate = numcal.min(1, fw / cw)
  let hRate = numcal.min(1, fh / ch)

  let rate = numcal.min(wRate, hRate)
  switch (policy) {
    case 'none':
      return contentSize;
    case 'fit':
      return {
        width: contentSize.width * rate,
        height: contentSize.height * rate
      }
    case 'fill':
      return {
        width: contentSize.width * rate,
        height: contentSize.height * rate
      }
    default:
      throw new Error(`Unknown policy: ${policy}`);
  }
}

module.exports = _scaledSize;
